package abcscriptgen;

import java.io.IOException;
import javax.swing.JOptionPane;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.nio.file.FileVisitResult;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.SimpleFileVisitor;
import java.nio.file.attribute.BasicFileAttributes;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

//trida reprezentujici uzivatelske rozhrani
public class GUI extends javax.swing.JFrame {

    ArrayList commands;
    fileIO fIO;
    directoryListing dL;
    scriptGenExec sG;
    String DATE_FORMAT = "dd_MM_yyyy_HH_mm_ss"; 
    
    public GUI() {
        initComponents();
        delAndCreateFolders();
        setTables();
        commands = new ArrayList();
        fIO = new fileIO();
        dL = new directoryListing();
        fillCircuits();       
    }
    
    //trida zajistujici mazani slozek
    class sfv extends SimpleFileVisitor<Path> {
        
        public sfv() { }
        
        @Override
        public FileVisitResult visitFile(Path file, BasicFileAttributes attrs) throws IOException
        {
            Files.deleteIfExists(file);
            return FileVisitResult.CONTINUE;
        }
        @Override
        public FileVisitResult postVisitDirectory(Path dir, IOException e) throws IOException {
            if (e == null) {
                Files.deleteIfExists(dir);
                return FileVisitResult.CONTINUE;
            } else { throw e; }
        }
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        commandsTable = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        summaryCommands = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        iterationCounter = new javax.swing.JSpinner();
        jScrollPane3 = new javax.swing.JScrollPane();
        circuitsTable = new javax.swing.JTable();
        Step1desc = new javax.swing.JLabel();
        Step2desc = new javax.swing.JLabel();
        Step3desc = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        summary = new javax.swing.JTextArea();
        runButton = new javax.swing.JButton();
        Step4desc = new javax.swing.JLabel();
        jScrollPane6 = new javax.swing.JScrollPane();
        permutationsTable = new javax.swing.JTable();
        selectAll = new javax.swing.JButton();
        Parameters = new javax.swing.JTextField();
        parametersLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("abcScriptGen v1.0");
        setMinimumSize(new java.awt.Dimension(1020, 300));
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        commandsTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"balance"},
                {"rewrite"},
                {"refactor"},
                {"resub"},
                {"rr"},
                {"collapse"}
            },
            new String [] {
                "logic synthesis"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });

        commandsTable.setColumnSelectionAllowed(true);
        jScrollPane1.setViewportView(commandsTable);
        commandsTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);

        getContentPane().add(jScrollPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(480, 30, 213, 120));

        jScrollPane2.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

        summaryCommands.setColumns(20);
        summaryCommands.setRows(5);
        jScrollPane2.setViewportView(summaryCommands);

        getContentPane().add(jScrollPane2, new org.netbeans.lib.awtextra.AbsoluteConstraints(480, 190, 213, 100));

        jLabel1.setText("Iteration count");
        getContentPane().add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(740, 260, -1, -1));

        iterationCounter.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(10), Integer.valueOf(1), null, Integer.valueOf(1)));
        getContentPane().add(iterationCounter, new org.netbeans.lib.awtextra.AbsoluteConstraints(830, 260, 61, -1));

        circuitsTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "circuits"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        circuitsTable.setColumnSelectionAllowed(true);
        jScrollPane3.setViewportView(circuitsTable);
        circuitsTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        circuitsTable.getColumnModel().getColumn(0).setResizable(false);

        getContentPane().add(jScrollPane3, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 30, 210, 190));

        Step1desc.setText("Step 1 - choose circuits");
        getContentPane().add(Step1desc, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 10, -1, -1));

        Step2desc.setText("Step 2 - choose permutations");
        getContentPane().add(Step2desc, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 10, -1, -1));

        Step3desc.setText("Step 3 - choose commands and it. count");
        getContentPane().add(Step3desc, new org.netbeans.lib.awtextra.AbsoluteConstraints(470, 10, -1, -1));

        summary.setColumns(20);
        summary.setRows(5);
        jScrollPane4.setViewportView(summary);

        getContentPane().add(jScrollPane4, new org.netbeans.lib.awtextra.AbsoluteConstraints(740, 30, 270, 220));

        runButton.setText("Run");
        runButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                Run_clicked(evt);
            }
        });
        getContentPane().add(runButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(950, 260, -1, -1));

        Step4desc.setText("Step 4 - view summary and run");
        getContentPane().add(Step4desc, new org.netbeans.lib.awtextra.AbsoluteConstraints(780, 10, -1, -1));

        permutationsTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"PI"},
                {"PO"},
                {"Node"},
                {"Term"}
            },
            new String [] {
                "permutation type"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        permutationsTable.setColumnSelectionAllowed(true);
        jScrollPane6.setViewportView(permutationsTable);
        permutationsTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        permutationsTable.getColumnModel().getColumn(0).setResizable(false);

        getContentPane().add(jScrollPane6, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 30, 100, 90));

        selectAll.setText("Select all");
        selectAll.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                selectAll_clicked(evt);
            }
        });
        getContentPane().add(selectAll, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 230, -1, -1));
        getContentPane().add(Parameters, new org.netbeans.lib.awtextra.AbsoluteConstraints(560, 160, 130, -1));

        parametersLabel.setText("Parameters");
        getContentPane().add(parametersLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(490, 160, -1, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents
    //spusteni prace abcScriptGen
    private void Run_clicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Run_clicked
        boolean sC, sP, sComm;
        String circ[], perm[], comm[];
        // kontrola vyberu obvodu, ulozeni vybranych do pole
        if (circuitsTable.getSelectedRows().length > 0) {
            sC = true;
            int circi[] = circuitsTable.getSelectedRows();
            circ = new String[circi.length];
            for (int i = 0; i < circi.length; i++) {
                circ[i] = circuitsTable.getValueAt(circi[i], 0).toString();
            }
        } else {
            sC = false;
            circ = null;
            JOptionPane.showMessageDialog(null, "Nevybran zadny obvod k testovani", "", JOptionPane.ERROR_MESSAGE);
        }        
        // kontrola vyberu permutace, ulozeni vybranych do pole
        if (permutationsTable.getSelectedRows().length > 0) {
            sP = true;
            int permi[] = permutationsTable.getSelectedRows();
            perm = new String[permi.length];
            for (int i = 0; i < permi.length; i++) {
                perm[i] = permutationsTable.getValueAt(permi[i], 0).toString();
            }
        } else {
            perm = null;
            sP = false;            
        }       
        //kontrola vyberu prikazu, ulozeni vybranych do pole
        if (!summaryCommands.getText().equals("")) {
            sComm = true;
            int commi = commands.size();
            comm = new String[commi];
            for (int i = 0; i < commi; i++) {
                comm[i] = commands.get(i).toString();
            }
        } else {
            comm = null;
            sComm = false;
            JOptionPane.showMessageDialog(null, "Nevybran zadny prikaz k provadeni", "", JOptionPane.ERROR_MESSAGE);
        }       
        //pri splneni podminek vyberu obvodu a prikazu pokracuj
        if (sC && sComm) {           
            int it = Integer.parseInt(iterationCounter.getValue().toString());
            createSummary(circ, perm, comm, sP, it);
            sG = new scriptGenExec(circ, perm, comm, sP, it);
            sG.start();
        }
    }//GEN-LAST:event_Run_clicked
    //tvorba prehledu do ctvrte tabulky
    private void createSummary(String[] circ, String[] perm, String[] comm , boolean sP, int it) {
        String summ = "";
        summ += "Selected circuits:\n";
        summ += "\n";
        for (int i = 0; i < circ.length; i++) {
            summ += circ[i] + "\n";
        }
        if(sP) {
            summ += "\n";
            summ += "Selected permutations:\n";
            summ += "\n";
            for (int i = 0; i < perm.length; i++) {
                summ += perm[i] + "\n";
            }
        }
        summ += "\n";
        summ += "Selected commands:\n";
        summ += "\n";
        for (int i = 0; i < comm.length; i++) {
            summ += comm[i] + "\n";
        }
        summ += "\n";
        summ += "Iteration count: " + it +"\n";
        summary.setText(summ);
    }  
    
    private void selectAll_clicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_selectAll_clicked
        circuitsTable.selectAll();
    }//GEN-LAST:event_selectAll_clicked
    //funkce pro naplneni prvni tabulky obvody ze slozky        
    private void fillCircuits() {
        ArrayList c = dL.listOnly(new File(System.getProperty("user.dir") + "\\circuits\\"));
        DefaultTableModel circuitsModdel = new DefaultTableModel() {   
            @Override
            public boolean isCellEditable(int row, int column)  
            {    
                return false;  
            }  
        }; 
        circuitsModdel.addColumn("circuits");        
        Vector temp;
        for (int i = 0; i < c.size(); i++) {
            temp = new Vector();
            temp.addElement(c.get(i).toString());
            circuitsModdel.addRow(temp);
        }
        circuitsTable.setModel(circuitsModdel);        
    }
    //funkce pro pripravu slozek na praci
    private void delAndCreateFolders() {
        Path errors = Paths.get(System.getProperty("user.dir") + "\\errorlogs");
        Path cos = Paths.get(System.getProperty("user.dir") + "\\circuitsorigstats");
        Path el = Paths.get(System.getProperty("user.dir") + "\\executionlog");
        Path p = Paths.get(System.getProperty("user.dir") + "\\permuted");
        Path r = Paths.get(System.getProperty("user.dir") + "\\results");
        Path s = Paths.get(System.getProperty("user.dir") + "\\scripts");
        Path best = Paths.get(System.getProperty("user.dir") + "\\best.blif");
        try {
            Files.delete(best);           
        } catch (IOException ex) { }
        try {
            Files.walkFileTree(errors, new sfv());           
        } catch (IOException ex) { }
        try {
            Files.walkFileTree(cos, new sfv());
        } catch (IOException ex) { }
        try {
            Files.walkFileTree(el, new sfv());
        } catch (IOException ex) { }
        try {
            Files.walkFileTree(p, new sfv());
        } catch (IOException ex) { }
        try {
            Files.walkFileTree(r, new sfv());
        } catch (IOException ex) { }
        try {
            Files.walkFileTree(s, new sfv());
        } catch (IOException ex) { }
        try {
            Files.createDirectory(errors);
            Files.createDirectory(cos);
            Files.createDirectory(el);
            Files.createDirectory(p);
            Files.createDirectory(r);
            Files.createDirectory(s);
        } catch (IOException ex) { }
    }
    //funkce pro upravu chovani tabulky s prikazy   
    private void setTables() {    
        commandsTable.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                if (e.getClickCount() == 2) {
                    JTable target = (JTable)e.getSource();
                    int row = target.getSelectedRow();
                    int column = target.getSelectedColumn();
                    String clickedCommand = commandsTable.getValueAt(row, column).toString();
                    if (!Parameters.getText().equals("")) {
                        clickedCommand += " " + Parameters.getText();
                    }
                    if (commands.indexOf(clickedCommand) == -1) {
                        commands.add(clickedCommand);
                    } else {
                        commands.remove(clickedCommand);
                    }
                    summaryCommands.setText("");
                    for (int i = 0; i < commands.size(); i++) {
                        summaryCommands.append(commands.get(i) + "\n");
                    }
                }
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField Parameters;
    private javax.swing.JLabel Step1desc;
    private javax.swing.JLabel Step2desc;
    private javax.swing.JLabel Step3desc;
    private javax.swing.JLabel Step4desc;
    private javax.swing.JTable circuitsTable;
    private javax.swing.JTable commandsTable;
    private javax.swing.JSpinner iterationCounter;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JLabel parametersLabel;
    private javax.swing.JTable permutationsTable;
    private javax.swing.JButton runButton;
    private javax.swing.JButton selectAll;
    private javax.swing.JTextArea summary;
    private javax.swing.JTextArea summaryCommands;
    // End of variables declaration//GEN-END:variables
}