package abcscriptgen;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import javax.swing.JOptionPane;

//trida pro generovani skriptu a jejich spousteni
public class scriptGenExec extends Thread{
    
    boolean sP;
    String[] circ, perm, comm;
    int it;
    fileIO fIO;
    runnerPermAbc rPA;
    String DATE_FORMAT = "dd_MM_yyyy_HH_mm_ss";
    
    public scriptGenExec(String[] circ, String[] perm, String[] comm , boolean sP, int it) {       
        this.sP = sP;
        this.circ = circ;
        this.perm = perm;
        this.comm = comm;
        this.it = it;
        fIO = new fileIO();
        rPA = new runnerPermAbc();
    }
    
    @Override
    public void run() {
        //vyber postupu provadeni testovani - zda s permutacemi ci nikoliv
        if (sP) {
            createCommandAndRun();
        } else {
            createCommandForWriteAndRun();
        }
        //volani pokud je treba provadet testovani realnych synteznich procesu - nepouzito v GUI
        //createCommandForSynth();
    }
    //funkce zajistujici provadeni testovani s permutacemi   
    public void createCommandAndRun() {        
        String command = "";
        boolean eA, pEA, errorP, errorA, printErrorP, printErrorA, firstTimeP, firstTimeA;
        //cyklus pro prochazeni vsech zvolenych obvodu        
        for (int i = 0; i < circ.length; i++) {
            fIO.appendToFile(System.getProperty("user.dir") + "\\executionlog\\execution.log", circ[i] + "\n");           
            //cyklus pro prochazeni vsech zvolenych permutaci
            for (int j = 0; j < perm.length; j++) {
                fIO.appendToFile(System.getProperty("user.dir") + "\\executionlog\\execution.log", perm[j] + "\n");
                //cyklus pro prochazeni vsech zvolenych prikazu
                for (int k = 0; k < comm.length; k++) {
                    command = "";
                    command += "read" + " " + System.getProperty("user.dir") + "\\circuits\\" + circ[i] + "\n";
                    if (!comm[k].equals("balance") && !comm[k].equals("collapse -r") && !comm[k].equals("collapse")) {
                        command += "strash" + "\n";
                    }
                    command += comm[k].replaceAll(" -r", "") + "\n";
                    command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv" + " " + circ[i] + " "+ "null" + " " + removeSpaces(comm[k].replaceAll(" -r", "")) + "\n";           
                    fIO.rewriteToFile(System.getProperty("user.dir") + "\\scripts\\" + "temp.scr", command);
                    if (comm[k].indexOf("collapse") != -1) {
                        if (!fIO.fileExists(System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv"))
                            fIO.appendToFile(System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv", "PRIKAZ;SIT;BDD;LEVEL\n");
                    } else {
                        if (!fIO.fileExists(System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv"))
                            fIO.appendToFile(System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv", "PRIKAZ;SIT;AND;LEVEL\n"); 
                    }
                    eA = false;
                    pEA = true;
                    eA = rPA.abcExec(0, pEA);
                    if (eA)
                        fIO.appendToFile(System.getProperty("user.dir") + "\\executionlog\\execution.log", "ERROR - ziskavani originalnich statistik obvodu" + "\n");
                    fIO.appendToFile(System.getProperty("user.dir") + "\\executionlog\\execution.log", comm[k] + "\n");
                    fIO.appendToFile(System.getProperty("user.dir") + "\\executionlog\\execution.log", "1..." + it + "\n");            
                    if (comm[k].indexOf("collapse") != -1) {
                        if (!fIO.fileExists(System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + perm[j] + ".csv")) 
                            fIO.appendToFile(System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + perm[j] + ".csv", "PRIKAZ;SIT;BDD;LEVEL\n");
                    } else {
                        if (!fIO.fileExists(System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + perm[j] + ".csv")) 
                            fIO.appendToFile(System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + perm[j] + ".csv", "PRIKAZ;SIT;AND;LEVEL\n"); 
                    }
                    //iteracni cyklus
                    errorP = false;
                    errorA = false;
                    printErrorP = true;
                    printErrorA = true;
                    firstTimeP = true;
                    firstTimeA = true;
                    for (int l = 0; l < it; l++) {
                        if (errorP && firstTimeP) {
                            fIO.appendToFile(System.getProperty("user.dir") + "\\executionlog\\execution.log", "ERROR - Permute" + "\n");
                            printErrorP = false;
                            firstTimeP = false;
                        }
                        if (errorA && firstTimeA) {
                            fIO.appendToFile(System.getProperty("user.dir") + "\\executionlog\\execution.log", "ERROR - ABC" + "\n");
                            printErrorA = false;
                            firstTimeA = false;
                        }
                        command = "";
                        command += "read" + " " + System.getProperty("user.dir") + "\\permuted\\" + circ[i].substring(0, circ[i].lastIndexOf(".")) + perm[j] + ".blif" + "\n";
                        if (!comm[k].equals("balance") && !comm[k].equals("collapse -r") && !comm[k].equals("collapse")) {
                            command += "strash" + "\n";
                        }
                        command += comm[k] + "\n";
                        command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + perm[j] + ".csv" + " " + circ[i] + " "+ perm[j] + " " + removeSpaces(comm[k]) + "\n";
                        fIO.rewriteToFile(System.getProperty("user.dir") + "\\scripts\\" + "temp.scr", command);
                        //spusteni permutaci
                        errorP = rPA.permExec(l, perm[j], circ[i], printErrorP);
                        //spusteni systemu ABC
                        errorA = rPA.abcExec(l, printErrorA);
                    }
                }   
            }
        }
        JOptionPane.showMessageDialog(null, "Hotovo", "", JOptionPane.ERROR_MESSAGE);
    }
    //funkce zajistujici provadeni testovani bez permutaci  
    public void createCommandForWriteAndRun() {
        String command = "";
        String scriptName = now() + ".scr";
        //cyklus pro prochazeni vsech zvolenych obvodu
        for (int i = 0; i < circ.length; i++) {                               
            //cyklus pro prochazeni vsech zvolenych prikazu
            for (int k = 0; k < comm.length; k++) {
                command = "";
                command += "read" + " " + System.getProperty("user.dir") + "\\circuits\\" + circ[i] + "\n";            
                if (!comm[k].equals("balance") && !comm[k].equals("collapse") && !comm[k].equals("collapse")) {
                    command += "strash" + "\n";
                }
                command += comm[k].replaceAll(" -r", "") + "\n";
                command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv" + " " + circ[i] + " " + "null" + " " + removeSpaces(comm[k].replaceAll(" -r", "")) + "\n";  
                fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
                if (comm[k].indexOf("collapse") != -1) {
                    if (!fIO.fileExists(System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv"))
                        fIO.appendToFile(System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv", "PRIKAZ;SIT;BDD;LEVEL\n");
                } else {
                    if (!fIO.fileExists(System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv"))
                        fIO.appendToFile(System.getProperty("user.dir") + "\\circuitsorigstats\\" + "origStats.csv", "PRIKAZ;SIT;AND;LEVEL\n"); 
                }
                if (comm[k].indexOf("collapse") != -1) {
                    if (!fIO.fileExists(System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + ".csv"))  
                        fIO.appendToFile(System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + ".csv", "PRIKAZ;SIT;BDD;LEVEL\n");
                } else {
                    if (!fIO.fileExists(System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + ".csv")) 
                        fIO.appendToFile(System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + ".csv", "PRIKAZ;SIT;AND;LEVEL\n"); 
                }
                //iteracni cyklus
                for (int l = 0; l < it; l++) {
                    command = "";
                    command += "read" + " " + System.getProperty("user.dir") + "\\circuits\\" + circ[i] + "\n";
                    if (!comm[k].equals("balance") && !comm[k].equals("collapse") && !comm[k].equals("collapse")) {
                        command += "strash" + "\n";
                    }
                    command += comm[k] + "\n";                       
                    command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + removeSpaces(comm[k]) + ".csv" + " " + circ[i] + " " + "null" + " " + removeSpaces(comm[k]) + "\n";
                    fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
                }                   
            }
        }       
        System.out.println("Generovani scriptu dokonceno");
        //spusteni systemu ABC
        rPA.abcExecGivenScript(1, true, scriptName);
        JOptionPane.showMessageDialog(null, "Hotovo", "", JOptionPane.ERROR_MESSAGE);
    }
    /*
    //funkce zajistujici provadeni testovani realnych synteznich procesu - CHOICE, MAP   
    public void createCommandForSynthMap() {
        String command = "";
        String scriptName = now() + ".scr";
        //cyklus pro prochazeni vsech zvolenych obvodu
        command += "read_library " + System.getProperty("user.dir") + "\\abc\\2-gates.genlib\n";
        command += "source " + System.getProperty("user.dir") + "\\abc\\abc.rc\n";
        for (int i = 0; i < circ.length; i++) {
            command += "read" + " " + System.getProperty("user.dir") + "\\circuits\\" + circ[i] + "\n";
            command += "strash" + "\n";
            //iteracni cyklus
            for (int l = 0; l < it; l++) {
                command += "choice" + "\n";
                command += "map" + "\n";
                command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + "choicemaporig.csv" + " " + circ[i] + " " + "null" + " " + "null" + "\n";
                command += "print_stats -b" + "\n";
                fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
                command = "";
            }
            command += "read" + " " + System.getProperty("user.dir") + "\\best.blif" + "\n";
            command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + "choicemapbestorig.csv" + " " + circ[i] + " " + "null" + " " + "null" + "\n";
            command += "fraig_clean\n";
            fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
            command = "";
        }    
        System.out.println("Generovani scriptu dokonceno");
        //spusteni systemu ABC
        rPA.abcExecGivenScript(1, true, scriptName);
        command = "";
        scriptName = now() + ".scr";
        //cyklus pro prochazeni vsech zvolenych obvodu
        command += "read_library " + System.getProperty("user.dir") + "\\abc\\2-gates.genlib\n";
        command += "source " + System.getProperty("user.dir") + "\\abc\\abc.rc\n";
        for (int i = 0; i < circ.length; i++) {
            command += "read" + " " + System.getProperty("user.dir") + "\\circuits\\" + circ[i] + "\n";
            command += "strash" + "\n";
            //iteracni cyklus
            for (int l = 0; l < it; l++) {
                command += "choicer" + "\n";
                command += "map" + "\n";
                command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + "choicemap.csv" + " " + circ[i] + " " + "null" + " " + "null" + "\n";
                command += "print_stats -b" + "\n";
                fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
                command = "";
            }
            command += "read" + " " + System.getProperty("user.dir") + "\\best.blif" + "\n";
            command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + "choicemapbest.csv" + " " + circ[i] + " " + "null" + " " + "null" + "\n";
            command += "fraig_clean\n";
            fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
            command = "";
        }    
        System.out.println("Generovani scriptu dokonceno");
        //spusteni systemu ABC
        rPA.abcExecGivenScript(1, true, scriptName);
        JOptionPane.showMessageDialog(null, "Hotovo", "", JOptionPane.ERROR_MESSAGE);
    }
    */
    /*
    //funkce zajistujici provadeni testovani realnych synteznich procesu - CHOICE, IF, LUTPACK
    public void createCommandForSynthLut() {
        String command = "";
        String scriptName = now() + ".scr";
        //cyklus pro prochazeni vsech zvolenych obvodu
        command += "source " + System.getProperty("user.dir") + "\\abc\\abc.rc\n";
        for (int i = 0; i < circ.length; i++) {
            command += "read" + " " + System.getProperty("user.dir") + "\\circuits\\" + circ[i] + "\n";
            command += "strash" + "\n";
            //iteracni cyklus
            for (int l = 0; l < it; l++) {
                command += "choice" + "\n";
                command += "if" + "\n";
                command += "lutpack" + "\n";
                command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + "choicelutorig.csv" + " " + circ[i] + " " + "null" + " " + "null" + "\n";
                command += "print_stats -b" + "\n";
                fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
                command = "";
            }
            command += "read" + " " + System.getProperty("user.dir") + "\\best.blif" + "\n";
            command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + "choicelutbestorig.csv" + " " + circ[i] + " " + "null" + " " + "null" + "\n";
            fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
            command = "";
        }    
        System.out.println("Generovani scriptu dokonceno");
        //spusteni systemu ABC
        rPA.abcExecGivenScript(1, true, scriptName);
        command = "";
        scriptName = now() + ".scr";
        //cyklus pro prochazeni vsech zvolenych obvodu
        command += "source " + System.getProperty("user.dir") + "\\abc\\abc.rc\n";
        for (int i = 0; i < circ.length; i++) {
            command += "read" + " " + System.getProperty("user.dir") + "\\circuits\\" + circ[i] + "\n";
            command += "strash" + "\n";
            //iteracni cyklus
            for (int l = 0; l < it; l++) {
                command += "choicer" + "\n";
                command += "if" + "\n";
                command += "lutpack" + "\n";
                command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + "choicelut.csv" + " " + circ[i] + " " + "null" + " " + "null" + "\n";
                command += "print_stats -b" + "\n";
                fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
                command = "";
            }
            command += "read" + " " + System.getProperty("user.dir") + "\\best.blif" + "\n";
            command += "print_stats_file" + " " + System.getProperty("user.dir") + "\\results\\" + "choicelutbest.csv" + " " + circ[i] + " " + "null" + " " + "null" + "\n";
            fIO.appendToFile(System.getProperty("user.dir") + "\\scripts\\" + scriptName, command);
            command = "";
        }    
        System.out.println("Generovani scriptu dokonceno");
        //spusteni systemu ABC
        rPA.abcExecGivenScript(1, true, scriptName);
        JOptionPane.showMessageDialog(null, "Hotovo", "", JOptionPane.ERROR_MESSAGE);
    }
    */
    //pomocna funkce pro odtraneni vsech mezer z textoveho retezce    
    private String removeSpaces(String text) {
        text = text.replaceAll(" ", "");
        return text;
    }
    //pomocna funkce vracejici aktualni cas a datum
    private String now() {
        Calendar cal = Calendar.getInstance();
        SimpleDateFormat sdf = null;
        sdf = new SimpleDateFormat(DATE_FORMAT);
        return sdf.format(cal.getTime());
    } 
    
}
